"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFile = exports.isReadableStream = exports.isUint8Array = void 0;
function isUint8Array(obj) {
    if (!obj || !obj.constructor)
        return false;
    if (typeof Uint8Array === 'function') {
        return obj instanceof Uint8Array;
    }
    return typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj);
}
exports.isUint8Array = isUint8Array;
function isReadableStream(value) {
    return value && typeof value.pipe === 'function' && value.readable !== false;
}
exports.isReadableStream = isReadableStream;
function isFile(value) {
    return value && typeof value.slice === 'function' && value.size && value.lastModified;
}
exports.isFile = isFile;
